-- Matrix (Colour Setting)
-- generates the effect from The Matrix with the option to change the colour

-- seed for the random number generator
property("seed", INTEGER, 0, 0)
property("Colour",COLOUR,0,255,0)

-- initialise the random number generator
math.randomseed(seed)

-- generate a random period,active,offset value for each column of the effect
table = {}
local i = 0
while (i < width) do
    table[i] = { math.random(1, 3), math.random(4, 10)/10, math.random() }
    i = i+1
end

-- ramp-down effect curve lookup
function ramp_down(f,period,active,offset)
    f = f/period
    f = f+offset
    f = f-math.floor(f)
    if (f>active) then return 0 else return f/active end
end

-- the pixel function
function pixel(frame, x, y)
    local t = frame/frames
    local period = table[x][1]
    local active = table[x][2]
    local offset = table[x][3]
    local f = ramp_down(y/height,period,active,1-t+offset)
    return Colour.red*f,Colour.green*f,Colour.blue*f
end

--[[
Copyright 2016 Pharos Architectural Controls Limited. All rights reserved.

This sample content is made freely available for illustrative purposes only. Pharos Architectural Controls grants a non-exclusive copyright licence to use this sample content from which you can generate content tailored to your own specific needs for use with products from Pharos Architectural Controls. This sample content has not been thoroughly tested under all conditions and Pharos Architectural Controls cannot guarantee reliability or serviceability.

This sample content is provided "as is" without warranties of any kind. The implied warranties of non-infringement, merchantability and fitness for a particular purpose are expressly disclaimed. In no event shall Pharos Architectural Controls be liable to any party for direct, indirect, incidental or consequential damages arising from the use of this sample content.

For further information please contact support@pharoscontrols.com.
--]]